#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <wfdb/wfdb.h>
#include <wfdb/ecgmap.h>


#define MAX_LEADS 12
#define MAX_SIGS  5
//#define MAX_LEN   31 000 000
#define MAX_BUF   100000
#define MAX_GAP   1000     

static WFDB_Siginfo s[MAX_LEADS];

double my0(int sample0);
double my2(int sample2);
double my3(int sample3);
double my4(int sample4);

unsigned stklen = 40000;
long nrSamps;
double *sig0;
double *sig1;
double *sig2;
double *sig3;
double *sig4;
double *sig5;


int m;
double dsum, dmin, dmax;
int openLeads;
long samples;
double normCnst = 65536;//32768;

double 
detectQRS(int detCh){
  long length;
  long i,j,k, max;
  double dmax=0;

  m=8;
  length = samples;

  //sig0[i]=0;
  for (i=0;i<m+2;i++){

    sig1[i]=0;
    sig2[i]=0;
    sig3[i]=0;
    sig4[i]=0;

  }
  for (i=0;i<length;i++) sig1[i] = my0(i);
  for (i=0;i<length;i++) sig2[i] = my2(i);
  for (i=0;i<length;i++) sig3[i] = my3(i);

  for (i=0;i<length;i++) {
    sig4[i] = my4(i)*sig3[i];
    if (sig4[i] > dmax) dmax = sig4[i];
  }

  dmax/=normCnst;

  for (i=0;i<length;i++) sig4[i]=(sig4[i]>dmax?1.0:0.0);

  for (i=0;i<length;i++){
    if (sig4[i]>0){
      for (j=i;j<i+36 && j<length;j++) sig4[j]=1.0;
      max = i+1;
      for (k=i+1;k<i+36 && k<length;k++)
	if ((sig0[max]-sig0[max-1])<(sig0[k]-sig0[k-1])) max=k;
      for (k=i;k<i+36 && k<length;k++) sig4[k]=0.0;
      sig4[max]=1.0;
      i+=35;
    }
  }
  return dmax;
}

double my0(int smp){
  double tempor=0.0;
  if ((smp>0) && (smp<samples-1))
    tempor = (sig0[smp-1]+2*sig0[smp]+sig0[smp+1])/4.0;
  return tempor;
}

double my2(int smp){
  long ki;
  double fsuma = 0;
  if ((smp>=m) && (smp<samples-m))
    for (ki=smp-m;ki<=smp+m;ki++) fsuma += sig1[ki];
  else return 0;
  fsuma /= (double)(2*m+1);
  return ((sig1[smp]-fsuma)*(sig1[smp]-fsuma));
}
double my3(int smp){
  long ki;
  double fsumi=0;
  if ((smp>=m) && (smp<samples-m)){
    for (ki=smp-m;ki<=smp+m;ki++) fsumi += sig2[ki];
    fsumi/=64.0;
    fsumi = sig2[smp]*fsumi*fsumi/64.0;
  }
  return fsumi;
}

double my4(int smp){
  if ((smp>=m) && (smp<samples-m))
    if ((sig1[smp]-sig1[smp-m])*(sig1[smp]-sig1[smp+m])<0)
      return 0.0;
    else return 1.0;
  else 
    return 0.0;
}

double
detectHeartBeat(){
  int i,j;
  double mean=0;
  double thresh;
  int inExtr=0;
  long idx=0, idxOrg;
  double gamma=0.85;
  double alpha=0.25;
  int wnd=20, lonePeak=0;
  FILE *out;
  m=15;
  for (i=0;i<samples;i++){
    sig1[i]=sig2[i]=sig3[i]=0.0;
    mean+=sig5[i];
  }
  mean/=samples;
  thresh=0;
  for (i=m;i<samples-m;i++){
    for (j=i-m;j<=i+m;j++) sig1[i]+=(sig5[j]-mean)*(sig5[j]-mean);
    thresh+=sig1[i];
  }
  /*
  out=fopen("DetectBeats.txt", "wt");
  for (i=0;i<samples;i++) fprintf(out,"%d %lf %lf \n", i, sig5[i], sig1[i]);
  fclose(out);
  */
  thresh=(thresh/samples)*1.2;
  inExtr=0;
  idx=-1;
  idxOrg=-1;
  for (i=0;i<samples;i++){
    if (sig1[i]>thresh){
      if (inExtr==0){
	inExtr=1;
	idx=i;
	idxOrg=i;
      }
      else{
	if (sig1[i]>sig1[idx]) idx=i;
	if (sig5[i]>sig5[idxOrg]) idxOrg=i;
      }
    }
    else 
      if (inExtr==1){
	lonePeak=0;
	for (j=i+1;j<i+wnd && i+wnd<samples;j++)
	  if (sig1[j]>thresh) lonePeak=1;
	if (lonePeak==0){
	  sig2[idx]=1;
	  sig3[idxOrg]=1;
	  inExtr=0;
	  thresh=(gamma)*thresh+(1-gamma)*(sig1[idx]*alpha);
	}
      }
  }
}

double
combineDetections(){
  long annotLag=0;
  long idxq=-1, idxb=-1;
  long prq, nxq;
  long idx=0;
  long wnd=35;
  int exists=0,i, k=2;
  double tmpM, tmpD;
  while (idx<samples && idxq<0){
    if (sig4[idx]>0) idxq=idx;
    idx++;
  }
  while (idx<samples && idxb<0){
    if (sig2[idx]>0) idxb=idx;
    idx++;
  }

  for (prq=idxb;prq>0 && sig4[prq]==0;prq--) ;
  for (nxq=idxb;nxq<samples && sig4[nxq]==0;nxq++) ;
  if (prq==0 || nxq == samples || idxq==-1){
    fprintf(stderr,"No beats detected\n");
    return;
  }
  annotLag = idxb-prq;
  //annotLag = (abs(idxb-prq)<abs(nxq-idxb)?idxb-prq:idxb-nxq);
  fprintf(stderr,"Annotation lag: %ld (%ld %ld)\n",annotLag,idxb-prq,idxb-nxq);
  //Check for missing QRS-s;
  for (idx=0;idx<samples;idx++){
    if (sig2[idx]==1){
      exists=0;
      /*
      for (idxq=(idx-annotLag-wnd>0?idx-annotLag-wnd:0);
	   idxq<=(idx-annotLag+wnd<0?0:idx-annotLag+wnd);
	   idxq++) if (sig4[idxq]==1) exists=1;
      */
      for (idxq=(idx-annotLag-wnd>0?idx-annotLag-wnd:0);idxq<=idx;idxq++)
	if (sig4[idxq]==1) exists=1;
      if (exists==0) {
	idxq=idx-annotLag;
	fprintf(stderr,"Adding %s=>%ld %ld \n", mstimstr(idxq), idx, idxq);
	//if (idxq>0) sig4[idxq]=1;
      }
    }
  }
  //Check for false QRS-s;
  for (idx=0;idx<samples;idx++){
    if (sig4[idx]==1){
      exists=0;
      /*
      for (idxq=(idx+annotLag-wnd<samples?idx+annotLag-wnd:samples);
	   idxq<=(idx+annotLag+wnd<samples-1?idx+annotLag+wnd:samples-1);
	   idxq++) if (sig2[idxq]==1) exists=1;
      */
      for (idxq=idx;
	   idxq<=(idx+annotLag+wnd<samples-1?idx+annotLag+wnd:samples-1);
	   idxq++) if (sig2[idxq]==1) exists=1;
      if (!exists){
	idxq=(idx+annotLag-k*wnd<samples?idx+annotLag-k*wnd:samples);
	idxb=(idx+annotLag+k*wnd<samples?idx+annotLag+k*wnd:samples);
	if (idxb-idxq>0){
	  tmpM=0;
	  tmpD=0;
	  for (i=idxq;i<idxb;i++) tmpM+=sig1[i];
	  tmpM/=(idxb-idxq);
	  for (i=idxq;i<idxb;i++) tmpD+=(sig1[i]-tmpM)*(sig1[i]-tmpM);
	  tmpD/=(idxb-idxq);
	  //fprintf(stderr,"%ld %lf %lf\n",idx, tmpM, tmpD);
	  if (2*tmpM<tmpD) {
	    fprintf(stderr,"Removing: %s\n", timstr(idx));
	    sig4[idx]=0;
	  }
	}
      }
    }
  }
  //for (idx=0;idx<samples;idx++) sig4[idx]=((int)sig4[idx])|((int)sig3[idx]);
  //if (sig2[idx]==1) sig4[idx]=1;
}

int
openRecord(char *record){
  return (isigopen(record, s, MAX_LEADS));
}

long ReadBuffer(long annot){
  long i,j, ecgI=0, bpI=0;
  WFDB_Sample vec[MAX_LEADS];

  for (j=0;j<openLeads;j++)
    if (strcmp(s[j].desc,"EEG")==0) ecgI=j;
    else if (strcmp(s[j].desc, "BP")==0) bpI=j;

  for (i=0;i<nrSamps;i++){
    if (getvec(vec)<0)
      break;
    //for (j=0;j<openLeads;j++) sig[j][i]=(vec[j]-s[j].baseline)/s[0].gain;    
    sig0[i]=1000*(vec[ecgI]-s[ecgI].baseline)/s[ecgI].gain;
    sig5[i]=(vec[bpI]-s[bpI].baseline)/s[bpI].gain;
    /* Transfer of a signal into mV, multiply by 1000 to get uV */
  }
  return(nrSamps);
}

void 
writeQRS(char *record, int chan, char *ann){
  WFDB_Anninfo annIFO;
  WFDB_Annotation annot;
  int i;

  annIFO.name = ann; annIFO.stat = WFDB_WRITE;
  if (annopen(record, &annIFO, 1) < 0){
    fprintf(stderr,"Error opening QRS file\n");
    return;
  }
  annot.subtyp = annot.chan = annot.num = 0; annot.aux = NULL;
  for (i=0;i<samples;i++){
    if (sig4[i]!=0){
      annot.anntyp = sig4[i];
      annot.time=i;
      if (putann(0, &annot) < 0) break;
    }
  }
}

void 
readQRS(char *record, char *ant, int chan){
  WFDB_Anninfo annIFO;
  WFDB_Annotation annot;
  long i;

  annIFO.name = ant; annIFO.stat = WFDB_READ;
  if (annopen(record, &annIFO, 1) < 0){
    fprintf(stderr,"Error opening QRS file\n");
    return;
  }
  annot.subtyp = annot.chan = annot.num = 0; annot.aux = NULL;
  for (i=0;i<samples;i++) sig4[i]=0;
  i=0;
  while (getann(0, &annot)==0) {
    if (annot.time>samples) {
      fprintf(stderr,"Error reading annotation times\n");
      return;
    }
    sig4[annot.time]=annot.anntyp;
  }
}

int
main(int argc, char *argv[]){
  long i;
  char *record = NULL;
  char *annotator=NULL;
  double thresh;
  
  for (i=1;i<argc;i++){
    if (argv[i][0]!='-'){
      fprintf(stderr,"Error parsing command line\n");
      exit(1);
    }
    switch (argv[i][1]){
    case 'r':
      i++;
      record = (char *)malloc(sizeof(char)*(strlen(argv[i])+2));
      strcpy(record,argv[i]);
      break;
    case 'a': 
      i++;
      annotator = (char *) malloc(sizeof(char)*(strlen(argv[i])+2));
      strcpy(annotator, argv[i]);
      break;
    case 'n': 
      i++;
      normCnst = atof(argv[i]);
      break;
    default:
      fprintf(stderr,"Wrong switch\n");
      exit (2);
    }
  }
  if (record == NULL){
    fprintf(stderr,"No record was specified, exiting\n");
    exit (2);
  }
  if ((openLeads=openRecord(record))<0){
    fprintf(stderr,"Error opening record, exiting\n");
    exit (3);
  }

  nrSamps = s->nsamp-1;
  sig0 = (double *)malloc(sizeof(double ) * nrSamps);
  sig1 = (double *)malloc(sizeof(double ) * nrSamps);
  sig2 = (double *)malloc(sizeof(double ) * nrSamps);
  sig3 = (double *)malloc(sizeof(double ) * nrSamps);
  sig4 = (double *)malloc(sizeof(double ) * nrSamps);
  sig5 = (double *)malloc(sizeof(double ) * nrSamps);
  if ((samples=ReadBuffer(0))<=0){
    fprintf(stderr,"Error opening record, exiting\n");
    exit (3);
  }
  if (samples!=nrSamps)
    fprintf(stderr,"Sample count differs\n");

  thresh=detectQRS(0);
  detectHeartBeat();
  //combineDetections();
  if (annotator==NULL){
    annotator=(char *)malloc(sizeof(char)*5);
    sprintf(annotator,"qrs");
  }
  writeQRS(record, 4, annotator);
  wfdbquit();
  free (sig0);
  free (sig1);
  free (sig2);
  free (sig3);
  free (sig4);
  free (sig5);
  free (annotator);
  return 0;
}

